<?php

	// Perform Login
	$CURRENT_MODULE_KEY = 'account_apk';
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, $CURRENT_MODULE_KEY);
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_ACC_APK_ID',
							'PARAM_ACC_APK_DESCRIPTION', 
							'PARAM_ACC_APK_SETTINGS_A', 
							'PARAM_ACC_APK_SETTINGS_B', 
							'PARAM_ACC_APK_SETTINGS_C', 
							'PARAM_ACC_APK_SETTINGS_D', 
							'PARAM_ACC_APK_SETTINGS_E', 
							'PARAM_ACC_APK_REMARKS', 
							'PARAM_ACC_APK_STATUS'
							// , 'PARAM_ACC_APK_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_ACC_APK_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_APK_ID', true);
			$PARAM_ACC_APK_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_DESCRIPTION', true);
			$PARAM_ACC_APK_SETTINGS_A = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_A', true);
			$PARAM_ACC_APK_SETTINGS_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_B', true);
			$PARAM_ACC_APK_SETTINGS_C = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_C', true);
			$PARAM_ACC_APK_SETTINGS_D = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_D', true);
			$PARAM_ACC_APK_SETTINGS_E = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_E', true);
			$PARAM_ACC_APK_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_REMARKS', true);
			$PARAM_ACC_APK_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_APK_STATUS', true);
			
			//$PARAM_ACC_APK_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_ACC_APK_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_ACC_APK_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_ACC_APK_ID,
							$PARAM_ACC_APK_DESCRIPTION, 
							$PARAM_ACC_APK_SETTINGS_A, 
							$PARAM_ACC_APK_SETTINGS_B, 
							$PARAM_ACC_APK_SETTINGS_C, 
							$PARAM_ACC_APK_SETTINGS_D, 
							$PARAM_ACC_APK_SETTINGS_E, 
							$PARAM_ACC_APK_REMARKS, 
							$PARAM_ACC_APK_STATUS
							// ,$PARAM_ACC_APK_ID_FILE['name']
					]
			);
			
			
			// Abort if already processed
			// ------------------------------------------------------------------
			$PARAM_REQUEST_UNIQUE_VALUE = null;
			if(PHPRC_HTTP_PARAM::REF_ISSET('PARAM_REQUEST_UNIQUE_VALUE'))
			{
				$PARAM_REQUEST_UNIQUE_VALUE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REQUEST_UNIQUE_VALUE', false);
			}
			
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
				$ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY); 
				if
				(
					$ARR_INDEX !== false &&
					PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] == $PARAM_REQUEST_UNIQUE_VALUE
				)
				{
					PHPCUS_PARAM::CUS_JSON_ERROR('Given Request is already processed.');
				}
			}
		
		
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_ACCOUNT_APK::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_ACC_APK_ID'] = $PARAM_ACC_APK_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_DESCRIPTION'] = $PARAM_ACC_APK_DESCRIPTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_A'] = $PARAM_ACC_APK_SETTINGS_A[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_B'] = $PARAM_ACC_APK_SETTINGS_B[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_C'] = $PARAM_ACC_APK_SETTINGS_C[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_D'] = $PARAM_ACC_APK_SETTINGS_D[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_E'] = $PARAM_ACC_APK_SETTINGS_E[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_REMARKS'] = $PARAM_ACC_APK_REMARKS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_APK_STATUS'] = $PARAM_ACC_APK_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_ACCOUNT_APK::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_ACC_APK_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						$FILE_PATH = PHPRC_UPLOAD::REF_SUGGEST_PATH
						(
							PHPSET::$ROOT . '/Upload/priv/Account/apk/', 
							$DATA_SET[0]['INSERTED_ID'],
							$PARAM_ACC_APK_ID_FILE['name'][$ARRAY_CTR]
						);
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_ACC_APK_ID_FILE['tmp_name'][$ARRAY_CTR],
							$FILE_PATH,
							true
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
					
					
			// Update processed request key
			// ------------------------------------------------------------------
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
				$ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY);
				if($ARR_INDEX !== false)
				{
					PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] = $PARAM_REQUEST_UNIQUE_VALUE;
				}
				else
				{
					array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY, $CURRENT_MODULE_KEY);
					array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE, $PARAM_REQUEST_UNIQUE_VALUE);
				}
			}			
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>